=== debian/changelog ===
onevpl-intel-gpu (25.1.4-1) unstable; urgency=medium

  * New upstream release.
  * patches: Add more BMG pci-id's. (LP: #2104011)

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 24 Mar 2025 16:30:12 +0200
