=== debian/control ===
Source: onevpl-intel-gpu
Section: graphics
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libdrm-dev,
 libva-dev,
 libvpl-dev,
 pkgconf,
Standards-Version: 4.6.0
Homepage: https://github.com/intel/vpl-gpu-rt
Vcs-Browser: https://salsa.debian.org/debian/onevpl-intel-gpu
Vcs-Git: https://salsa.debian.org/debian/onevpl-intel-gpu.git
Rules-Requires-Root: no

Package: libmfx-gen1.2
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel VPL GPU Runtime -- shared library
 Intel Video Processing Library GPU Runtime is a Runtime implementation of
 Intel VPL API for Intel Gen GPUs. Runtime provides access to
 hardware-accelerated video decode, encode and filtering.
 .
 Supported video encoders: HEVC, AVC, MPEG-2, JPEG, VP9  
 Supported video decoders: HEVC, AVC, VP8, VP9, MPEG-2, VC1, JPEG, AV1, VVC
 Supported video pre-processing filters: Color Conversion, Deinterlace, Denoise,
 Resize, Rotate, Composition  
 .
 This package includes the shared library.

Package: libmfx-gen-dev
Architecture: amd64
Depends: ${misc:Depends},
 libmfx-gen1.2 (= ${binary:Version})
Description: Intel VPL GPU Runtime -- development files
 Intel Video Processing Library GPU Runtime is a Runtime implementation of
 Intel VPL API for Intel Gen GPUs. Runtime provides access to
 hardware-accelerated video decode, encode and filtering.
 .
 Supported video encoders: HEVC, AVC, MPEG-2, JPEG, VP9  
 Supported video decoders: HEVC, AVC, VP8, VP9, MPEG-2, VC1, JPEG, AV1, VVC
 Supported video pre-processing filters: Color Conversion, Deinterlace, Denoise,
 Resize, Rotate, Composition  
 .
 This package includes files for development.
